=== debian/changelog ===
shiboken2 (2.0.0.dev0-0~201704211731~rev1707~pkg43~ubuntu16.10.1) yakkety; urgency=low

  * Auto build.

 -- Thomas Karl Pietrowski <thopiekar@googlemail.com>  Fri, 21 Apr 2017 17:31:42 +0000
